package cachet.plugins.notifications

import android.annotation.SuppressLint
import android.app.Notification
import android.content.Intent
import android.os.Build
import android.service.notification.NotificationListenerService
import android.service.notification.StatusBarNotification
import android.util.Log
import androidx.annotation.RequiresApi

/**
 * Notification listening service. Intercepts notifications if permission is given to do so.
 */
@RequiresApi(Build.VERSION_CODES.JELLY_BEAN_MR2)
@SuppressLint("OverrideAbstract")
class AndroidnotifyListener : NotificationListenerService() {
    private val TAG = AndroidnotifyListener::class.java.simpleName
    override fun onCreate() {
        super.onCreate()
    }

    override fun onListenerConnected() {
        //当连接成功时调用，一般在开启监听后会回调一次该方法
        Log.d(TAG, "onListenerConnected")
    }

    @RequiresApi(Build.VERSION_CODES.KITKAT)
    override fun onNotificationPosted(sbn: StatusBarNotification) {
        Log.d(TAG, "通知测试,$sbn")
        val packageName = sbn.packageName
        val text = sbn.notification.extras.getString(Notification.EXTRA_TEXT)
        val title = sbn.notification.extras.getString(Notification.EXTRA_TITLE)
        val intent = Intent(NOTIFICATION_INTENT)
        intent.putExtra(NOTIFICATION_PACKAGE_NAME, packageName)
        intent.putExtra(NOTIFICATION_TITLE, title)
        intent.putExtra(NOTIFICATION_TEXT, text)
        sendBroadcast(intent)
    }

    companion object {

        var NOTIFICATION_INTENT = "notification_event"
        var NOTIFICATION_PACKAGE_NAME = "package_name"
        var NOTIFICATION_TITLE = "title"
        var NOTIFICATION_TEXT = "text"
    }
}