import 'dart:async';

import 'package:flutter/services.dart';

class NotificationEvent {
  String _packageName;
  DateTime _timeStamp;

  NotificationEvent(this._packageName) {
    _timeStamp = DateTime.now();
  }

  String get packageName => _packageName;
  DateTime get timeStamp => _timeStamp;

  @override
  String toString() {
    return "[$packageName sent notification @ $timeStamp";
  }
}

NotificationEvent _notificationEvent(String event) {
  return new NotificationEvent(event);
}
class Androidnotify {
  static const EventChannel _channel =
      const EventChannel('androidnotify');

  Stream<NotificationEvent> _notificationStream;

  Stream<NotificationEvent> get stream {
    if (_notificationStream == null) {
      _notificationStream = _channel
          .receiveBroadcastStream()
          .map((event) => _notificationEvent(event));
    }
    return _notificationStream;
  }
}
